
exports.up = function(knex, Promise) {
    return knex.schema.createTable('messages_private_posts', function (table) {
        table.increments('mid'); //autoincrementing (non-nullable) primary key
        table.timestamps(true, true); //adds timestamptz-type (a PostgresQL data type) updated_at and created_at columns

        table.string('title').notNullable();
        table.text('content');
        
        table.string('recipient',128).notNullable().defaultTo('noone')
            .references('gid').inTable('groups')
            .onDelete('CASCADE'); //if recipient is deleted, also delete the private post (don't direct to noone to avoid spamming it, + supposed to be private)
        table.string('author').notNullable(); //must refer to a User's uid.
    });
};

exports.down = function(knex, Promise) {
    return knex.schema.dropTable('messages_private_posts');
};
