
exports.up = function(knex, Promise) {
    return knex.schema.createTable('messages_questions', function (table) {
        table.increments('mid'); //autoincrementing (non-nullable) primary key
        table.timestamps(true, true); //adds timestamptz-type (a PostgresQL data type) updated_at and created_at columns

        table.string('title').notNullable();
        table.text('content');
        
        table.string('recipient',128).notNullable().defaultTo('noone')
            .references('gid').inTable('groups')
            .onDelete('SET DEFAULT'); //if recipient is deleted, direct to the special "no-one" group
        table.string('author').notNullable(); //must refer to a User's uid.

        /* 
        we cannot declare this column yet, as table 'answers' is not yet created.
        it will be declared in the migration for the 'answers' childtable.
        table.integer('for_answer')
            .references('mid').inTable('answers')
            .onDelete('SET NULL'); //if answer is deleted, set for_answer to null
        */    
    });
};

exports.down = function(knex, Promise) {
    return knex.schema.dropTable('messages_questions');
};
