
exports.up = function (knex, Promise) {
    return knex.schema.createTable('requests_user_join_group', function (table) {
        table.increments('rid'); //autoincrementing (non-nullable) primary key
        table.timestamps(true, true); //adds timestamptz-type (a PostgresQL data type) updated_at and created_at columns

        table.text('request_comment');
        table.string('request_from').notNullable(); //must refer to a User's uid.
        table.string('request_to',128).notNullable()
            .references('gid').inTable('groups')
            .onDelete('CASCADE'); //delete request from database if recipient group is deleted
    });
};

exports.down = function (knex, Promise) {
    return knex.schema.dropTable('requests_user_join_group');
};
