
/**
 * Noter que contrairement aux seed files suivants, ceci ne contient pas d'entrées de test
 * mais des entrées qui doivent être mises dans la BDD même en prod...
 */

exports.seed = async function (knex, Promise) {
    // Deletes ALL existing entries
    // first we have to delete all the messages, because deleting 'noone' would trigger their ON DELETE, which would require 'noone' to exist...
    await knex('messages_announcements').del();
    await knex('messages_events').del();
    //await knex('messages_private_posts').del(); <-- ok this one is safe, because we set ON DELETE CASCADE (and not SET DEFAULT)
    await knex('messages_questions').del();
    await knex('messages_answers').del();
    await knex('groups').del();
    // Inserts seed entries
    const special_groups = [{
        name: 'Special root group',
        gid: 'root',
        description: 'root group, theoretically the ancestor of all SimpleGroups',
        school: 'notaschool',
        parent_gid: 'root',
        type: 'simple'
    }, {
        name: "Special 'no-one' group",
        gid: 'noone',
        description: "'noone' group, direct child of 'root' group.\
            Serves as recipient of all unpublished Messages (e.g.drafts, messages with deleted recipient...)",
        school: 'polytechnique',
        parent_gid: 'root',
        type: 'simple'
    }
    ];

    return knex('groups').insert(special_groups)
        .then(console.log("finished running 00_special_groups"));

};
